﻿using System.Xml.Serialization;
using HMI_Base;

namespace HMI_Base
{
    /// <summary>
    /// 円ボタン要素
    /// </summary>
    /// <remarks>
    /// 属性名はXmlAttributeで定義します。
    /// </remarks>
    public class HMI_ButtonCircleElem : HMI_ButtonElem
    {
        /// <summary>
        /// コンストラクタ
        /// </summary>
        public HMI_ButtonCircleElem()
        {
            // 初期設定
            FontSize = "20px";
            Left = "0px";
            Top = "0px";
            Width = "100px";
            Height = Width;
            BackColor = "silver";
        }

    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_ButtonCircleGreen_Xml
    {
        [XmlArrayItem("HMI_ButtonCircleGreen")]
        public List<HMI_ButtonCircleElem>? HMI_ButtonCircleGreens = null;
    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_ButtonCircleRed_Xml
    {
        [XmlArrayItem("HMI_ButtonCircleRed")]
        public List<HMI_ButtonCircleElem>? HMI_ButtonCircleReds = null;
    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_ButtonCircleRoyalblue_Xml
    {
        [XmlArrayItem("HMI_ButtonCircleRoyalblue")]
        public List<HMI_ButtonCircleElem>? HMI_ButtonCircleRoyalblues = null;
    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_ButtonCircleOrange_Xml
    {
        [XmlArrayItem("HMI_ButtonCircleOrange")]
        public List<HMI_ButtonCircleElem>? HMI_ButtonCircleOranges = null;
    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_ButtonCircleDarkblueOver_Xml
    {
        [XmlArrayItem("HMI_ButtonCircleDarkblueOver")]
        public List<HMI_ButtonCircleElem>? HMI_ButtonCircleDarkblueOvers = null;
    }

    /// <summary>
    /// ログ表示 xmlのロード
    /// </summary>
    public partial class HMI_LoadXml
    {
        /// <summary>
        /// ボタン 円
        /// </summary>
        /// <param name="hmiButtonCircleGreenXml"></param>
        static public void Load_HMI_ButtonCircleGreen_Xml(string folderName,ref HMI_ButtonCircleGreen_Xml hmiButtonCircleGreenXml)
        {
            hmiButtonCircleGreenXml = LoadFromXml<HMI_ButtonCircleGreen_Xml>($"{folderName}/HMI_ButtonCircleGreen.xml");
            if (null != hmiButtonCircleGreenXml)
            {
                if (null != hmiButtonCircleGreenXml.HMI_ButtonCircleGreens)
                {
                    foreach (var Item in hmiButtonCircleGreenXml.HMI_ButtonCircleGreens)
                    {
                        // 文字色の設定
                        Item.ForeColor = "black";
                        // 背景色の設定
                        Item.BackColor = "green";
                        // 高さの設定
                        Item.Height = Item.Width;
                    }
                }
            }
        }
        /// <summary>
        /// ボタン 円 赤
        /// </summary>
        /// <param name="hmiButtonCircleRedXml"></param>
        static public void Load_HMI_ButtonCircleRed_Xml(string folderName, ref HMI_ButtonCircleRed_Xml hmiButtonCircleRedXml)
        {
            hmiButtonCircleRedXml = LoadFromXml<HMI_ButtonCircleRed_Xml>($"{folderName}/HMI_ButtonCircleRed.xml");
            if (null != hmiButtonCircleRedXml)
            {
                if (null != hmiButtonCircleRedXml.HMI_ButtonCircleReds)
                {
                    foreach (var Item in hmiButtonCircleRedXml.HMI_ButtonCircleReds)
                    {
                        // 文字色の設定
                        Item.ForeColor = "black";
                        // 背景色の設定
                        Item.BackColor = "red";
                        // 高さの設定
                        Item.Height = Item.Width;
                    }
                }
            }
        }
        /// <summary>
        /// ボタン 円 薄青
        /// </summary>
        /// <param name="hmiButtonCircleRoyalblueXml"></param>
        static public void Load_HMI_ButtonCircleRoyalblue_Xml(string folderName, ref HMI_ButtonCircleRoyalblue_Xml hmiButtonCircleRoyalblueXml)
        {
            hmiButtonCircleRoyalblueXml = LoadFromXml<HMI_ButtonCircleRoyalblue_Xml>($"{folderName}/HMI_ButtonCircleRoyalblue.xml");
            if (null != hmiButtonCircleRoyalblueXml)
            {
                if (null != hmiButtonCircleRoyalblueXml.HMI_ButtonCircleRoyalblues)
                {
                    foreach (var Item in hmiButtonCircleRoyalblueXml.HMI_ButtonCircleRoyalblues)
                    {
                        // 文字色の設定
                        Item.ForeColor = "black";
                        // 背景色の設定
                        Item.BackColor = "#008DDD";
                        // 高さの設定
                        Item.Height = Item.Width;
                    }
                }
            }
        }
        /// <summary>
        /// ボタン 円 オレンジ
        /// </summary>
        /// <param name="hmiButtonCircleOrangeXml"></param>
        static public void Load_HMI_ButtonCircleOrange_Xml(string folderName, ref HMI_ButtonCircleOrange_Xml hmiButtonCircleOrangeXml)
        {
            hmiButtonCircleOrangeXml = LoadFromXml<HMI_ButtonCircleOrange_Xml>($"{folderName}/HMI_ButtonCircleOrange.xml");
            if (null != hmiButtonCircleOrangeXml)
            {
                if (null != hmiButtonCircleOrangeXml.HMI_ButtonCircleOranges)
                {
                    foreach (var Item in hmiButtonCircleOrangeXml.HMI_ButtonCircleOranges)
                    {
                        // 文字色の設定
                        Item.ForeColor = "White";
                        // 背景色の設定
                        Item.BackColor = "#FF6600";
                        // 高さの設定
                        Item.Height = Item.Width;
                    }
                }
            }
        }
        /// <summary>
        /// ボタン 円 濃青 マウスオーバー
        /// </summary>
        /// <param name="hmiButtonCircleDarkblueOverXml"></param>
        static public void Load_HMI_ButtonCircleDarkblueOver_Xml(string folderName, ref HMI_ButtonCircleDarkblueOver_Xml hmiButtonCircleDarkblueOverXml)
        {
            hmiButtonCircleDarkblueOverXml = LoadFromXml<HMI_ButtonCircleDarkblueOver_Xml>($"{folderName}/HMI_ButtonCircleDarkblueOver.xml");
            if (null != hmiButtonCircleDarkblueOverXml)
            {
                if (null != hmiButtonCircleDarkblueOverXml.HMI_ButtonCircleDarkblueOvers)
                {
                    foreach (var Item in hmiButtonCircleDarkblueOverXml.HMI_ButtonCircleDarkblueOvers)
                    {
                        // 文字色の設定
                        Item.ForeColor = "White";
                        // 背景色の設定
                        Item.BackColor = "#1b2538";
                        // 背景色の設定(マウスオーバー時)
                        Item.BackColorOver = "#A9BDE2";
                        // 高さの設定
                        Item.Height = Item.Width;
                    }
                }
            }
        }
    }
}
