﻿using System.Xml.Serialization;
using HMI_Base;
using HMI_CommonLibrary;

namespace HMI_Base
{
    /// <summary>
    /// チャート(折れ線)要素
    /// </summary>
    /// <remarks>
    /// 属性名はXmlAttributeで定義します。
    /// </remarks>
    public class HMI_ChartBarElem : HMI_ChartElem
    {
        /// チャートID
        /// </summary>
        [XmlAttribute("ChartId")]
        public string ChartId = "";

        /// チャートType
        /// </summary>
        [XmlAttribute("ChartType")]
        public string ChartType = "";

        /// チャートデータ1 Label
        /// </summary>
        [XmlAttribute("ChartData1_Label")]
        public string ChartData1_Label = "Data1";

        /// チャートデータ1 YAxisID
        /// </summary>
        [XmlAttribute("ChartData1_YAxisID")]
        public string ChartData1_YAxisID = "y1";

        /// チャートデータ1 BorderColor
        /// </summary>
        [XmlAttribute("ChartData1_BorderColor")]
        public string ChartData1_BorderColor = "rgba(255, 0, 0, 0.4)";

        /// チャートデータ1 BackgroundColor
        /// </summary>
        [XmlAttribute("ChartData1_BackgroundColor")]
        public string ChartData1_BackgroundColor = "rgba(255, 0, 0, 1)";

        /// チャートデータ1 BorderWidth
        /// </summary>
        [XmlAttribute("ChartData1_BorderWidth")]
        public string ChartData1_BorderWidth = "1";

        /// チャートデータ1 Fill
        /// </summary>
        [XmlAttribute("ChartData1_Fill")]
        public string ChartData1_Fill = "false";

        /// チャートデータ2 Label
        /// </summary>
        [XmlAttribute("ChartData2_Label")]
        public string ChartData2_Label = "Data2";

        /// チャートデータ2 YAxisID
        /// </summary>
        [XmlAttribute("ChartData2_YAxisID")]
        public string ChartData2_YAxisID = "y1";

        /// チャートデータ2 BorderColor
        /// </summary>
        [XmlAttribute("ChartData2_BorderColor")]
        public string ChartData2_BorderColor = "rgba(255, 0, 0, 0.4)";

        /// チャートデータ2 BackgroundColor
        /// </summary>
        [XmlAttribute("ChartData2_BackgroundColor")]
        public string ChartData2_BackgroundColor = "rgba(255, 0, 0, 1)";

        /// チャートデータ2 BorderWidth
        /// </summary>
        [XmlAttribute("ChartData2_BorderWidth")]
        public string ChartData2_BorderWidth = "1";

        /// チャートデータ2 Fill
        /// </summary>
        [XmlAttribute("ChartData2_Fill")]
        public string ChartData2_Fill = "false";

        /// チャートデータ3 Label
        /// </summary>
        [XmlAttribute("ChartData3_Label")]
        public string ChartData3_Label = "Data3";

        /// チャートデータ1 YAxisID
        /// </summary>
        [XmlAttribute("ChartData3_YAxisID")]
        public string ChartData3_YAxisID = "y2";

        /// チャートデータ3 BorderColor
        /// </summary>
        [XmlAttribute("ChartData3_BorderColor")]
        public string ChartData3_BorderColor = "rgba(255, 0, 0, 0.4)";

        /// チャートデータ3 BackgroundColor
        /// </summary>
        [XmlAttribute("ChartData3_BackgroundColor")]
        public string ChartData3_BackgroundColor = "rgba(255, 0, 0, 1)";

        /// チャートデータ3 BorderWidth
        /// </summary>
        [XmlAttribute("ChartData3_BorderWidth")]
        public string ChartData3_BorderWidth = "1";

        /// チャートデータ3 Fill
        /// </summary>
        [XmlAttribute("ChartData3_Fill")]
        public string ChartData3_Fill = "false";

        /// チャートオプション responsive
        /// </summary>
        [XmlAttribute("ChartOpt_responsive")]
        public string ChartOpt_responsive = "true";

        /// チャートオプション title display
        /// </summary>
        [XmlAttribute("ChartOpt_Plugins_Title_Display")]
        public string ChartOpt_Plugins_Title_Display = "false";

        /// チャートオプション title text
        /// </summary>
        [XmlAttribute("ChartOpt_Plugins_Title_Text")]
        public string ChartOpt_Plugins_Title_Text = "N/A";

        /// チャートオプション title color
        /// </summary>
        [XmlAttribute("ChartOpt_Plugins_Title_Color")]
        public string ChartOpt_Plugins_Title_Color = "rgba(80, 80, 80, 1)";

        /// チャートオプション title fontsize
        /// </summary>
        [XmlAttribute("ChartOpt_Plugins_Title_FontSize")]
        public string ChartOpt_Plugins_Title_FontSize = "18";

        /// チャートオプション tooltip mode
        /// </summary>
        [XmlAttribute("ChartOpt_Tooltip_Mode")]
        public string ChartOpt_Tooltip_Mode = "point";

        /// チャートオプション tooltip intersect
        /// </summary>
        [XmlAttribute("ChartOpt_Tooltip_Intersect")]
        public string ChartOpt_Tooltip_Intersect = "true";

        /// チャートオプション Scales X_Type    linearとcategoryとtimeしかサポートしない
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_X_Type")]
        public string ChartOpt_Scales_X_Type = "category";

        /// チャートオプション Scales X_Id
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_X_Id")]
        public string ChartOpt_Scales_X_Id = "N/A";

        /// チャートオプション Scales X_Position
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_X_Position")]
        public string ChartOpt_Scales_X_Position = "bottom";

        /// チャートオプション Scales X_Ticks_Display
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_X_Ticks_Display")]
        public string ChartOpt_Scales_X_Ticks_Display = "true";

        /// チャートオプション Scales X_Ticks_FontSize
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_X_Ticks_FontSize")]
        public string ChartOpt_Scales_X_Ticks_FontSize = "14";

        /// チャートオプション Scales X_Ticks_Color
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_X_Ticks_Color")]
        public string ChartOpt_Scales_X_Ticks_Color = "#000";

        /// チャートオプション Scales X_Ticks_StepSize
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_X_Ticks_StepSize")]
        public string ChartOpt_Scales_X_Ticks_StepSize = "1";

        /// チャートオプション Scales Y1_ID
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y1_ID")]
        public string ChartOpt_Scales_Y1_ID = "Y1";

        /// チャートオプション Scales Y1_Type    linearとcategoryとtimeしかサポートしない
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y1_Type")]
        public string ChartOpt_Scales_Y1_Type = "linear";

        /// チャートオプション Scales Y1 position
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y1_Position")]
        public string ChartOpt_Scales_Y1_Position = "left";

        /// チャートオプション Scales Y1 Ticks_FontSize
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y1_Ticks_FontSize")]
        public string ChartOpt_Scales_Y1_Ticks_FontSize = "14";

        /// チャートオプション Scales Y1 Ticks_Color
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y1_Ticks_Color")]
        public string ChartOpt_Scales_Y1_Ticks_Color = "#000";

        /// チャートオプション Scales Y1 BeginAtZero
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y1_BeginAtZero")]
        public string ChartOpt_Scales_Y1_BeginAtZero = "true";

        /// チャートオプション Scales Y1 Ticks_Display
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y1_Ticks_Display")]
        public string ChartOpt_Scales_Y1_Ticks_Display = "true";

        /// チャートオプション Scales_Y1_Ticks_StepSize
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y1_Ticks_StepSize")]
        public string ChartOpt_Scales_Y1_Ticks_StepSize = "1";

        /// チャートオプション Scales Y2_ID
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y2_ID")]
        public string ChartOpt_Scales_Y2_ID = "Y2";

        /// チャートオプション Scales Y2_Type    linearとcategoryとtimeしかサポートしない
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y2_Type")]
        public string ChartOpt_Scales_Y2_Type = "linear";

        /// チャートオプション Scales Y2 position
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y2_Position")]
        public string ChartOpt_Scales_Y2_Position = "right";

        /// チャートオプション Scales Y2 Ticks_FontSize
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y2_Ticks_FontSize")]
        public string ChartOpt_Scales_Y2_Ticks_FontSize = "14";

        /// チャートオプション Scales Y2 Ticks_Color
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y2_Ticks_Color")]
        public string ChartOpt_Scales_Y2_Ticks_Color = "#000";

        /// チャートオプション Scales Y2 BeginAtZero
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y2_BeginAtZero")]
        public string ChartOpt_Scales_Y2_BeginAtZero = "true";

        /// チャートオプション Scales Y2 Ticks_Display
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y2_Ticks_Display")]
        public string ChartOpt_Scales_Y2_Ticks_Display = "true";

        /// チャートオプション Scales_Y2_Ticks_StepSize
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Y2_Ticks_StepSize")]
        public string ChartOpt_Scales_Y2_Ticks_StepSize = "1";

        /// チャートオプション Scales Grid_Display
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Grid_Display")]
        public string ChartOpt_Scales_Grid_Display = "true";

        /// チャートオプション Scales Grid_BorderColor
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Grid_BorderColor")]
        public string ChartOpt_Scales_Grid_BorderColor = "rgba(80, 80, 80, 1)";

        /// チャートオプション Scales Grid_Color
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Grid_Color")]
        public string ChartOpt_Scales_Grid_Color = "rgba(80, 80, 80, 1)";

        /// チャートオプション Scales Grid_TickColor
        /// </summary>
        [XmlAttribute("ChartOpt_Scales_Grid_TickColor")]
        public string ChartOpt_Scales_Grid_TickColor = "rgba(80, 80, 80, 1)";

        /// チャートオプション 凡例 Plugins_Legend_Display
        /// </summary>
        [XmlAttribute("ChartOpt_Plugins_Legend_Display")]
        public string ChartOpt_Plugins_Legend_Display = "false";

        /// チャートオプション 凡例 Plugins_Legend_Position
        /// </summary>
        [XmlAttribute("ChartOpt_Plugins_Legend_Position")]
        public string ChartOpt_Plugins_Legend_Position = "top";

        /// チャートオプション 凡例 Plugins_Legend_Labels_boxWidth
        /// </summary>
        [XmlAttribute("ChartOpt_Plugins_Legend_Labels_BoxWidth")]
        public string ChartOpt_Plugins_Legend_Labels_BoxWidth = "40";

        /// チャートオプション 凡例 Plugins_Legend_Labels_fontSize
        /// </summary>
        [XmlAttribute("ChartOpt_Plugins_Legend_Labels_FontSize")]
        public string ChartOpt_Plugins_Legend_Labels_FontSize = "14";
        /// <summary>
        /// テーブルData
        /// </summary>
        [XmlElement("ChartDataSets")]
        public HMI_ChartBar.XmlChartDataSets XmlDataSets { get; set; }
        [XmlIgnore]
        ///
        /// edge側へ問い合わせるタグ名
        ///
        public List<string> TagNames { get; set; }
        [XmlIgnore]
        public Dictionary<string, HmiData> ChartTagDataDic { get; set; }
        [XmlIgnore]

        public HMI_ChartBar.ChartDataSet Chart_X_DataSet { get; set; }
        [XmlIgnore]
        public List<HMI_ChartBar.ChartDataSet> Chart_Y_DataSetList { get; set; }



        /// <summary>
        /// コンストラクタ
        /// </summary>
        public HMI_ChartBarElem()
        {
            // 初期設定
            ChartType = "bar";
            ChartOpt_responsive = "true";
            ChartOpt_Plugins_Title_Display = "false";
            ChartOpt_Plugins_Title_Text = "N/A";
            ChartOpt_Plugins_Title_Color = "rgba(80, 80, 80, 1)";
            ChartOpt_Plugins_Title_FontSize = "18";
            ChartOpt_Tooltip_Mode = "point";
            ChartOpt_Tooltip_Intersect = "true";
            ChartOpt_Scales_X_Type = "category";
            ChartOpt_Scales_X_Id = "N/A";
            ChartOpt_Scales_X_Position = "bottom";
            ChartOpt_Scales_X_Ticks_Display = "true";
            ChartOpt_Scales_X_Ticks_FontSize = "14";
            ChartOpt_Scales_X_Ticks_Color = "#000";
            ChartOpt_Scales_X_Ticks_StepSize = "1";
            ChartOpt_Scales_Y1_ID = "Y1";
            ChartOpt_Scales_Y1_Type = "linear";
            ChartOpt_Scales_Y1_Position = "left";
            ChartOpt_Scales_Y1_Ticks_FontSize = "14";
            ChartOpt_Scales_Y1_Ticks_Color = "#000";
            ChartOpt_Scales_Y1_BeginAtZero = "true";
            ChartOpt_Scales_Y1_Ticks_Display = "true";
            ChartOpt_Scales_Y1_Ticks_StepSize = "1";

            ChartOpt_Scales_Y2_ID = "Y2";
            ChartOpt_Scales_Y2_Type = "linear";
            ChartOpt_Scales_Y2_Position = "right";
            ChartOpt_Scales_Y2_Ticks_FontSize = "14";
            ChartOpt_Scales_Y2_Ticks_Color = "#000";
            ChartOpt_Scales_Y2_BeginAtZero = "true";
            ChartOpt_Scales_Y2_Ticks_Display = "true";
            ChartOpt_Scales_Y2_Ticks_StepSize = "1";

            ChartOpt_Scales_Grid_Display = "true";
            ChartOpt_Scales_Grid_BorderColor = "rgba(80, 80, 80, 1)";
            ChartOpt_Scales_Grid_Color = "rgba(80, 80, 80, 1)";
            ChartOpt_Scales_Grid_TickColor = "rgba(80, 80, 80, 1)";

            ChartOpt_Plugins_Legend_Display = "false";
            ChartOpt_Plugins_Legend_Position = "top";
            ChartOpt_Plugins_Legend_Labels_BoxWidth = "40";
            ChartOpt_Plugins_Legend_Labels_FontSize = "14";

            XmlDataSets = new HMI_ChartBar.XmlChartDataSets();
            Chart_X_DataSet = new HMI_ChartBar.ChartDataSet();
            Chart_Y_DataSetList = new List<HMI_ChartBar.ChartDataSet>();
            ChartTagDataDic = new Dictionary<string, HmiData>();
            TagNames = new List<string>();
            FontSize = "20px";
            Left = "0px";
            Top = "0px";
            Width = "100px";
            Height = Width;
            BackColor = "silver";
        }

    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_ChartBarBlack_Xml
    {
        [XmlArrayItem("HMI_ChartBarBlack")]
        public List<HMI_ChartBarElem>? HMI_ChartBarBlacks = null;
    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_ChartBarWhite_Xml
    {
        [XmlArrayItem("HMI_ChartBarWhite")]
        public List<HMI_ChartBarElem>? HMI_ChartBarWhites = null;
    }
    /// <summary>
    /// XMLのロード
    /// </summary>
    public partial class HMI_LoadXml
    {
        /// <summary>
        /// 黒色 チャート 棒グラフ
        /// </summary>
        /// <param name="hmiChartBarBlackXml"></param>
        static public void Load_HMI_ChartBarBlack_Xml(string folderName, ref HMI_ChartBarBlack_Xml hmiChartBarBlackXml)
        {
            hmiChartBarBlackXml = LoadFromXml<HMI_ChartBarBlack_Xml>($"{folderName}/HMI_ChartBarBlack.xml");
            if (null != hmiChartBarBlackXml)
            {
                if (null != hmiChartBarBlackXml.HMI_ChartBarBlacks)
                {
                    foreach (var Item in hmiChartBarBlackXml.HMI_ChartBarBlacks)
                    {

                        // ログに出力1
                        // 背景色の設定
                        Item.BackColor = "Black";
                        // 折れ線1の色の設定
                        Item.ChartData1_BorderColor = "rgba(255, 99, 132, 1)";
                        // 折れ線1の背景色の設定
                        Item.ChartData1_BackgroundColor = "rgba(255, 99, 132, 1)";
                        // 折れ線2の色の設定
                        Item.ChartData2_BorderColor = "rgba(54, 162, 235, 1)";
                        // 折れ線2の背景色の設定
                        Item.ChartData2_BackgroundColor = "rgba(54, 162, 235, 1)";
                        // 折れ線3の色の設定
                        Item.ChartData3_BorderColor = "rgba(255, 205, 86, 1)";
                        // 折れ線3の背景色の設定
                        Item.ChartData3_BackgroundColor = "rgba(255, 205, 86, 1)";
                        // X軸の文字色の設定
                        Item.ChartOpt_Scales_X_Ticks_Color = "#fff";
                        // Y1軸の文字色の設定
                        Item.ChartOpt_Scales_Y1_Ticks_Color = "#fff";
                        // Y2軸の文字色の設定
                        Item.ChartOpt_Scales_Y2_Ticks_Color = "#fff";
                        // グリッドの枠線の色の設定
                        Item.ChartOpt_Scales_Grid_BorderColor = "black";
                        // グリッドの内部の背景色の設定
                        Item.ChartOpt_Scales_Grid_Color = "black";
                        // 目盛りの線の色の設定
                        Item.ChartOpt_Scales_Grid_TickColor = "black";
                        // グラフのIDを設定
                        Item.ChartId = "ChartBarBlack_" + Item.ChartId;
                        // 折れ線グラフの設定
                        Item.ChartType = "bar";
                        // 軸にy1とy2以外を指定した場合の設定
                        if (Item.ChartData1_YAxisID != "y1" && Item.ChartData1_YAxisID != "y2")
                            Item.ChartData1_YAxisID = "y1";
                        if (Item.ChartData2_YAxisID != "y1" && Item.ChartData2_YAxisID != "y2")
                            Item.ChartData2_YAxisID = "y1";
                        if (Item.ChartData3_YAxisID != "y1" && Item.ChartData3_YAxisID != "y2")
                            Item.ChartData3_YAxisID = "y1";

                        if (null != Item.ChartTagDataDic && null != Item.XmlDataSets && null != Item.XmlDataSets.XmlChartDataSetList)
                        {
                            Item.ChartTagDataDic.Clear(); //空にする
                            Item.TagNames.Clear();      //空にする
                            Item.Chart_Y_DataSetList.Clear(); //空にする
                            foreach (var ChartDataSet in Item.XmlDataSets.XmlChartDataSetList)
                            {
                                if (null != ChartDataSet.XmlDatas && 0 != ChartDataSet.XmlDatas.Count())
                                {
                                    HMI_ChartBar.ChartDataSet cDataSet = new HMI_ChartBar.ChartDataSet();
                                    cDataSet.Axis = ChartDataSet.Axis;
                                    cDataSet.Digit = ChartDataSet.Digit;
                                    cDataSet.IsTag = ChartDataSet.IsTag;
                                    foreach (var DataName in ChartDataSet.XmlDatas)
                                    {
                                        HmiData TagData = new HmiData() { TagName = DataName, TagValue = DataName, Digit = ChartDataSet.Digit, IsTag = ChartDataSet.IsTag };
                                        //タグの時RT-edgeから読込対象とする
                                        if (ChartDataSet.IsTag == true)
                                        {
                                            Item.TagNames.Add(DataName);
                                            if (!Item.ChartTagDataDic.ContainsKey(DataName))
                                                Item.ChartTagDataDic.Add(DataName, TagData);
                                        }
                                        cDataSet.Datas.Add(TagData);
                                    }
                                    if (ChartDataSet.Axis == "x")
                                        Item.Chart_X_DataSet = cDataSet;
                                    else
                                        Item.Chart_Y_DataSetList.Add(cDataSet);
                                }
                            }
                        }
                    }
                }
            }
        }
        /// <summary>
        /// 白色 チャート 棒グラフ
        /// </summary>
        /// <param name="hmiChartBarWhiteXml"></param>
        static public void Load_HMI_ChartBarWhite_Xml(string folderName, ref HMI_ChartBarWhite_Xml hmiChartBarWhiteXml)
        {
            hmiChartBarWhiteXml = LoadFromXml<HMI_ChartBarWhite_Xml>($"{folderName}/HMI_ChartBarWhite.xml");
            if (null != hmiChartBarWhiteXml)
            {
                if (null != hmiChartBarWhiteXml.HMI_ChartBarWhites)
                {
                    foreach (var Item in hmiChartBarWhiteXml.HMI_ChartBarWhites)
                    {

                        // ログに出力1
                        // 背景色の設定
                        Item.BackColor = "White";
                        // 折れ線1の色の設定
                        Item.ChartData1_BorderColor = "rgba(255, 99, 132, 1)";
                        // 折れ線1の背景色の設定
                        Item.ChartData1_BackgroundColor = "rgba(255, 99, 132, 1)";
                        // 折れ線2の色の設定
                        Item.ChartData2_BorderColor = "rgba(54, 162, 235, 1)";
                        // 折れ線2の背景色の設定
                        Item.ChartData2_BackgroundColor = "rgba(54, 162, 235, 1)";
                        // 折れ線3の色の設定
                        Item.ChartData3_BorderColor = "rgba(255, 205, 86, 1)";
                        // 折れ線3の背景色の設定
                        Item.ChartData3_BackgroundColor = "rgba(255, 205, 86, 1)";
                        // X軸の文字色の設定
                        Item.ChartOpt_Scales_X_Ticks_Color = "#000";
                        // Y1軸の文字色の設定
                        Item.ChartOpt_Scales_Y1_Ticks_Color = "#000";
                        // Y2軸の文字色の設定
                        Item.ChartOpt_Scales_Y2_Ticks_Color = "#000";
                        // グリッドの枠線の色の設定
                        Item.ChartOpt_Scales_Grid_BorderColor = "black";
                        // グリッドの内部の背景色の設定
                        Item.ChartOpt_Scales_Grid_Color = "White";
                        // 目盛りの線の色の設定
                        Item.ChartOpt_Scales_Grid_TickColor = "black";
                        // グラフのIDを設定
                        Item.ChartId = "ChartBarWhite_" + Item.ChartId;
                        // 折れ線グラフの設定
                        Item.ChartType = "bar";
                        // 軸にy1とy2以外を指定した場合の設定
                        if (Item.ChartData1_YAxisID != "y1" && Item.ChartData1_YAxisID != "y2")
                            Item.ChartData1_YAxisID = "y1";
                        if (Item.ChartData2_YAxisID != "y1" && Item.ChartData2_YAxisID != "y2")
                            Item.ChartData2_YAxisID = "y1";
                        if (Item.ChartData3_YAxisID != "y1" && Item.ChartData3_YAxisID != "y2")
                            Item.ChartData3_YAxisID = "y1";

                        if (null != Item.ChartTagDataDic && null != Item.XmlDataSets && null != Item.XmlDataSets.XmlChartDataSetList)
                        {
                            Item.ChartTagDataDic.Clear(); //空にする
                            Item.TagNames.Clear();      //空にする
                            Item.Chart_Y_DataSetList.Clear(); //空にする
                            foreach (var ChartDataSet in Item.XmlDataSets.XmlChartDataSetList)
                            {
                                if (null != ChartDataSet.XmlDatas && 0 != ChartDataSet.XmlDatas.Count())
                                {
                                    HMI_ChartBar.ChartDataSet cDataSet = new HMI_ChartBar.ChartDataSet();
                                    cDataSet.Axis = ChartDataSet.Axis;
                                    cDataSet.Digit = ChartDataSet.Digit;
                                    cDataSet.IsTag = ChartDataSet.IsTag;
                                    foreach (var DataName in ChartDataSet.XmlDatas)
                                    {
                                        HmiData TagData = new HmiData() { TagName = DataName, TagValue = DataName, Digit = ChartDataSet.Digit, IsTag = ChartDataSet.IsTag };
                                        //タグの時RT-edgeから読込対象とする
                                        if (ChartDataSet.IsTag == true)
                                        {
                                            Item.TagNames.Add(DataName);
                                            if (!Item.ChartTagDataDic.ContainsKey(DataName))
                                                Item.ChartTagDataDic.Add(DataName, TagData);
                                        }
                                        cDataSet.Datas.Add(TagData);
                                    }
                                    if (ChartDataSet.Axis == "x")
                                        Item.Chart_X_DataSet = cDataSet;
                                    else
                                        Item.Chart_Y_DataSetList.Add(cDataSet);
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
