﻿using System.Xml.Serialization;
using HMI_Base;

namespace HMI_Base
{
    public class HMI_FrameElem : HMI_TileElem
    {
        /// <summary>
        /// URL 読み込み
        /// </summary>
        [XmlAttribute("Source")]
        public string Source = "";
        /// <summary>
        /// フレームID
        /// </summary>
        [XmlAttribute("Id")]
        public string Id = "";
        /// <summary>
        /// 枠線の有無
        /// </summary>
        [XmlAttribute("Border")]
        public string Border = "";
        /// <summary>
        /// TileScrolling
        /// </summary>
        [XmlAttribute("Scrolling")]
        public string Scrolling = "";
        /// <summary>
        /// 背景色
        /// </summary>
        [XmlAttribute("Backgroundcolor")]
        public string Backgroundcolor = "";
        /// <summary>
        /// 回転、拡大、縮小、移動、傾斜などの変形
        /// </summary>
        [XmlAttribute("Transform")]
        public string Transform = "";
        /// <summary>
        /// 配置方法
        /// </summary>
        [XmlAttribute("Position")]
        public string Position = "";
        /// <summary>
        /// タグで指定かどうか
        /// </summary>
        [XmlAttribute("IsTag")]
        public string IsTag = "false";

    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_FrameGray_Xml
    {
        [XmlArrayItem("HMI_FrameGray")]
        public List<HMI_FrameElem>? HMI_FrameGrays = null;
    }
    /// <summary>
    /// ログ表示 xmlのロード
    /// </summary>
    public partial class HMI_LoadXml
    {
        /// <summary>
        /// IFrame XML グレー
        /// </summary>
        /// <param name="hmiFrameGrayXml"></param>
        static public void Load_HMI_FrameGray_Xml(string folderName, ref HMI_FrameGray_Xml hmiFrameGrayXml)
        {
            hmiFrameGrayXml = LoadFromXml<HMI_FrameGray_Xml>($"{folderName}/HMI_FrameGray.xml");
            if (null != hmiFrameGrayXml)
            {
                if (null != hmiFrameGrayXml.HMI_FrameGrays)
                {
                    foreach (var Item in hmiFrameGrayXml.HMI_FrameGrays)
                    {
                        // 背景色の設定
                        // Item.Backgroundcolor = "#000000";
                    }
                }
            }
        }
    }
}
