﻿using System.Xml.Serialization;
using HMI_Base;

namespace HMI_Base
{
    /// <summary>
    /// 固定ラベル要素
    /// </summary>
    /// <remarks>
    /// 属性名はXmlAttributeで定義します。
    /// </remarks>
    public class HMI_LabelFixElem : HMI_LabelElem
	{
        /// <summary>
        /// コンストラクタ
        /// </summary>
        public HMI_LabelFixElem()
        {
            // 初期設定
            FontSize = "20px";
            Left = "0px";
            Top = "0px";
            Width = "400px";
        }

    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_LabelFixBlack_Xml
    {
        [XmlArrayItem("HMI_LabelFixBlack")]
        public List<HMI_LabelFixElem>? HMI_LabelFixBlacks = null;
    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_LabelFixRed_Xml
    {
        [XmlArrayItem("HMI_LabelFixRed")]
        public List<HMI_LabelFixElem>? HMI_LabelFixReds = null;
    }
    /// <summary>
    /// ログ表示 xmlのロード
    /// </summary>
    public partial class HMI_LoadXml
    {
        /// <summary>
        /// ラベル 黒
        /// </summary>
        /// <param name="hmiLabelFixBlackXml"></param>
        static public void Load_HMI_LabelFixBlack_Xml(string folderName, ref HMI_LabelFixBlack_Xml hmiLabelFixBlackXml)
        {
            hmiLabelFixBlackXml = LoadFromXml<HMI_LabelFixBlack_Xml>($"{folderName}/HMI_LabelFixBlack.xml");
            if (null != hmiLabelFixBlackXml)
            {
                if (null != hmiLabelFixBlackXml.HMI_LabelFixBlacks)
                {
                    foreach (var Item in hmiLabelFixBlackXml.HMI_LabelFixBlacks)
                    {
                        // 文字色の設定
                        Item.ForeColor = "black";
                        // 背景色の設定
                        Item.BackColor = "silver";
                    }
                }
            }
        }
        /// <summary>
        /// ラベル 赤
        /// </summary>
        /// <param name="hmiLabelFixRedXml"></param>
        static public void Load_HMI_LabelFixRed_Xml(string folderName, ref HMI_LabelFixRed_Xml hmiLabelFixRedXml)
        {
            hmiLabelFixRedXml = LoadFromXml<HMI_LabelFixRed_Xml>($"{folderName}/HMI_LabelFixRed.xml");
            if (null != hmiLabelFixRedXml)
            {
                if (null != hmiLabelFixRedXml.HMI_LabelFixReds)
                {
                    foreach (var Item in hmiLabelFixRedXml.HMI_LabelFixReds)
                    {
                        // 文字色の設定
                        Item.ForeColor = "red";
                        // 背景色の設定
                        Item.BackColor = "silver";
                    }
                }
            }
        }
    }
}
