﻿using System.Xml.Serialization;
using HMI_Base;

namespace HMI_Base
{
    /// <summary>
    /// タグラベル要素
    /// </summary>
    /// <remarks>
    /// 属性名はXmlAttributeで定義します。
    /// </remarks>
    public class HMI_LabelTagElem : HMI_LabelElem
	{
        /// 表示桁数
        /// </summary>
        [XmlAttribute("Digit")]
        public int Digit = 0;

        /// <summary>
        /// コンストラクタ
        /// </summary>
        public HMI_LabelTagElem()
        {
            // 初期設定
            FontSize = "20px";
            Left = "0px";
            Top = "0px";
            Width = "200px";
            Height = "100px";
            Digit = 3;
            Zindex = "1";
        }

    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_LabelTagBlack_Xml
    {
        [XmlArrayItem("HMI_LabelTagBlack")]
        public List<HMI_LabelTagElem>? HMI_LabelTagBlacks = null;
    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_LabelTagRed_Xml
    {
        [XmlArrayItem("HMI_LabelTagRed")]
        public List<HMI_LabelTagElem>? HMI_LabelTagReds = null;
    }
    /// <summary>
    /// ログ表示 xmlのロード
    /// </summary>
    public partial class HMI_LoadXml
    {
        /// <summary>
        /// ラベル 黒 タグ
        /// </summary>
        /// <param name="hmiLabelTagBlackXml"></param>
        static public void Load_HMI_LabelTagBlack_Xml(string folderName, ref HMI_LabelTagBlack_Xml hmiLabelTagBlackXml)
        {
            hmiLabelTagBlackXml = LoadFromXml<HMI_LabelTagBlack_Xml>($"{folderName}/HMI_LabelTagBlack.xml");
            if (null != hmiLabelTagBlackXml)
            {
                if (null != hmiLabelTagBlackXml.HMI_LabelTagBlacks)
                {
                    foreach (var Item in hmiLabelTagBlackXml.HMI_LabelTagBlacks)
                    {
                        // 文字色の設定
                        Item.ForeColor = "black";
                        // 背景色の設定
                        Item.BackColor = "silver";
                    }
                }
            }
        }
        /// <summary>
        /// ラベル 赤
        /// </summary>
        /// <param name="hmiLabelTagRedXml"></param>
        static public void Load_HMI_LabelTagRed_Xml(string folderName, ref HMI_LabelTagRed_Xml hmiLabelTagRedXml)
        {
            hmiLabelTagRedXml = LoadFromXml<HMI_LabelTagRed_Xml>($"{folderName}/HMI_LabelTagRed.xml");
            if (null != hmiLabelTagRedXml)
            {
                if (null != hmiLabelTagRedXml.HMI_LabelTagReds)
                {
                    foreach (var Item in hmiLabelTagRedXml.HMI_LabelTagReds)
                    {
                        // 文字色の設定
                        Item.ForeColor = "red";
                        // 背景色の設定
                        Item.BackColor = "silver";
                    }
                }
            }
        }
    }
}
