﻿using System.Xml.Serialization;
using HMI_Base;

namespace HMI_Base
{
    /// <summary>
    /// 円ランプ要素
    /// </summary>
    /// <remarks>
    /// 属性名はXmlAttributeで定義します。
    /// </remarks>
    public class HMI_LampCircleElem : HMI_LampElem
	{
        /// <summary>
        /// コンストラクタ
        /// </summary>
        public HMI_LampCircleElem()
        {
            // 初期設定
            FontSize = "20px";
            Left = "0px";
            Top = "0px";
            Width = "100px";
            Height = Width;
            BackColor = "silver";
        }

    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_LampCircleGreen_Xml
    {
        [XmlArrayItem("HMI_LampCircleGreen")]
        public List<HMI_LampCircleElem>? HMI_LampCircleGreens = null;
    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_LampCircleRed_Xml
    {
        [XmlArrayItem("HMI_LampCircleRed")]
        public List<HMI_LampCircleElem>? HMI_LampCircleReds = null;
    }
    /// <summary>
    /// ログ表示 xmlのロード
    /// </summary>
    public partial class HMI_LoadXml
    {
        /// <summary>
        /// Xmlファイルの読み込み ランプ 円 緑
        /// </summary>
        /// <param name="hmiLampCircleGreenXml"></param>
        static public void Load_HMI_LampCircleGreen_Xml(string folderName, ref HMI_LampCircleGreen_Xml hmiLampCircleGreenXml)
        {
            hmiLampCircleGreenXml = LoadFromXml<HMI_LampCircleGreen_Xml>($"{folderName}/HMI_LampCircleGreen.xml");
            if (null != hmiLampCircleGreenXml)
            {
                if (null != hmiLampCircleGreenXml.HMI_LampCircleGreens)
                {
                    foreach (var Item in hmiLampCircleGreenXml.HMI_LampCircleGreens)
                    {
                        // 文字色の設定
                        Item.ForeColor = "black";
                        // 高さの設定
                        Item.Height = Item.Width;
                    }
                }
            }
        }
        /// <summary>
        /// Xmlファイルの読み込み ランプ 円 赤
        /// </summary>
        /// <param name="hmiLampCircleRedXml"></param>
        static public void Load_HMI_LampCircleRed_Xml(string folderName, ref HMI_LampCircleRed_Xml hmiLampCircleRedXml)
        {
            hmiLampCircleRedXml = LoadFromXml<HMI_LampCircleRed_Xml>($"{folderName}/HMI_LampCircleRed.xml");
            if (null != hmiLampCircleRedXml)
            {
                if (null != hmiLampCircleRedXml.HMI_LampCircleReds)
                {
                    foreach (var Item in hmiLampCircleRedXml.HMI_LampCircleReds)
                    {
                        // 文字色の設定
                        Item.ForeColor = "black";
                        // 高さの設定
                        Item.Height = Item.Width;
                    }
                }
            }
        }
    }
}
