﻿using System.Xml.Serialization;
using HMI_Base;

namespace HMI_Base
{
    /// <summary>
    /// 四角ランプ要素
    /// </summary>
    /// <remarks>
    /// 属性名はXmlAttributeで定義します。
    /// </remarks>
    public class HMI_LampRectElem : HMI_LampElem
	{
        /// <summary>
        /// コンストラクタ
        /// </summary>
        public HMI_LampRectElem()
        {
            // 初期設定
            FontSize = "20px";
            Left = "0px";
            Top = "0px";
            Width = "200px";
            Height = "100px";
            BackColor = "silver";
        }

    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_LampRectGreen_Xml
    {
        [XmlArrayItem("HMI_LampRectGreen")]
        public List<HMI_LampRectElem>? HMI_LampRectGreens = null;
    }

    /// <summary>
    /// xml情報
    /// </summary>
	public class HMI_LampRectRed_Xml
    {
        [XmlArrayItem("HMI_LampRectRed")]
        public List<HMI_LampRectElem>? HMI_LampRectReds = null;
    }
    /// <summary>
    /// ログ表示 xmlのロード
    /// </summary>
    public partial class HMI_LoadXml
    {
        /// <summary>
        /// XML読込 四角 ランプ 緑
        /// </summary>
        /// <param name="hmiLampRectGreenXml"></param>
        static public void Load_HMI_LampRectGreen_Xml(string folderName, ref HMI_LampRectGreen_Xml hmiLampRectGreenXml)
        {
            hmiLampRectGreenXml = LoadFromXml<HMI_LampRectGreen_Xml>($"{folderName}/HMI_LampRectGreen.xml");
            if (null != hmiLampRectGreenXml)
            {
                if (null != hmiLampRectGreenXml.HMI_LampRectGreens)
                {
                    foreach (var Item in hmiLampRectGreenXml.HMI_LampRectGreens)
                    {
                        // 文字色の設定
                        Item.ForeColor = "black";
                    }
                }
            }
        }
        /// <summary>
        /// XML読込 四角 ランプ 赤
        /// </summary>
        /// <param name="hmiLampRectRedXml"></param>
        static public void Load_HMI_LampRectRed_Xml(string folderName, ref HMI_LampRectRed_Xml hmiLampRectRedXml)
        {
            hmiLampRectRedXml = LoadFromXml<HMI_LampRectRed_Xml>($"{folderName}/HMI_LampRectRed.xml");
            if (null != hmiLampRectRedXml)
            {
                if (null != hmiLampRectRedXml.HMI_LampRectReds)
                {
                    foreach (var Item in hmiLampRectRedXml.HMI_LampRectReds)
                    {
                        // 文字色の設定
                        Item.ForeColor = "black";
                    }
                }
            }
        }
    }
}
