﻿using System.Xml.Serialization;
using HMI_Base;

namespace HMI_Base
{
#nullable disable
    /// <summary>
    /// 基底となる要素
    /// </summary>
    /// <remarks>
    /// 属性名はXmlAttributeで定義します。
    /// </remarks>
    public class HMI_TileElem
    {
        // ----------------------------------------
        // xmlで読み込みたい要素を定義
        // ----------------------------------------
        /// <summary>
        /// タグ名
        /// </summary>
        [XmlAttribute("Tag")]
        public string Tag = "";
        /// <summary>
        /// 表示文字列
        /// </summary>
        [XmlAttribute("Text")]
        public string Text = "";
        /// <summary>
        /// 背景色
        /// </summary>
		[XmlAttribute("BackColor")]
        public string BackColor = "";
        /// <summary>
        /// 文字色
        /// </summary>
		[XmlAttribute("ForeColor")]
        public string ForeColor = "";

        /// <summary>
        /// フォントサイズ(TileFontSize)
        /// </summary>
        [XmlAttribute("FontSize")]
        public string FontSize = "";

        /// <summary>
        /// タイル位置指定(Top)
        /// </summary>
        [XmlAttribute("Top")]
        public string Top = "";

        /// <summary>
        /// タイル位置指定(Left)
        /// </summary>
        [XmlAttribute("Left")]
        public string Left = "";

        /// <summary>
        /// タイルの表示幅(TileWidth)
        /// </summary>
        [XmlAttribute("Width")]
        public string Width = "";

        /// <summary>
        /// タイルの表示高さ(TileHeight)
        /// </summary>
        [XmlAttribute("Height")]
        public string Height = "";

        /// <summary>
        /// タイル位置指定(Zindex)
        /// </summary>
        [XmlAttribute("Zindex")]
        public String Zindex = "";


        // ----------------------------------------
        // クラス内で使用(xmlからは読み込みしない)
        // ----------------------------------------
        /// <summary>
        /// 現在値
        /// </summary>
        public string Value = "";

        /// <summary>
        /// コンストラクタ
        /// </summary>
        public HMI_TileElem()
        {
        }

    }
    public partial class HMI_LoadXml
    {
        static private T LoadFromXml<T>(string fileName)
             where T : class
        {
            // ファイルパスの設定
            string xmlFilePath = Path.Combine(System.AppContext.BaseDirectory, fileName);
            // 指定したファイルの読み込み
            return MnXmlUtility.LoadFromFile<T>(xmlFilePath);
        }
    }
#nullable restore
}
