﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using Microsoft.AspNetCore.Http;

public class IpAddressService
{
    private readonly IHttpContextAccessor _httpContextAccessor;

    public IpAddressService(IHttpContextAccessor httpContextAccessor)
    {
        _httpContextAccessor = httpContextAccessor;
    }

    public string GetIpAddress()
    {
        var context = _httpContextAccessor.HttpContext;

        if (context?.Connection?.RemoteIpAddress != null)
        {
            return context.Connection.RemoteIpAddress.ToString();
        }

        return "IPアドレスを取得できません";
    }
}