////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using HMI_Base;
using HMI_Base.Components;
using Microsoft.AspNetCore.Authentication;
using Microsoft.AspNetCore.Authentication.Cookies;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Components.Authorization;
using Microsoft.AspNetCore.Components.Server.Circuits;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Server.Kestrel.Core;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using Serilog;
;
// WebAvP[Ṽr_[쐬
var builder = WebApplication.CreateBuilder(args);

// T[rXReiɒǉ
builder.Services.AddRazorComponents() // RazorR|[lgǉ
    .AddInteractiveServerComponents(); // C^NeBuT[o[R|[lgǉ

// HttpContextAccessoro^
builder.Services.AddHttpContextAccessor();
builder.Services.AddScoped<IpAddressService>();

// ݒǂݍ
var authSettings = builder.Configuration.GetSection("AuthenticationSettings").Get<AuthenticationSettings>();
if (authSettings != null && authSettings.IsLoginEnabled) // OCL̏ꍇ
{
    // F،ñT[rXǉ
    builder.Services.AddAuthentication(CookieAuthenticationDefaults.AuthenticationScheme)
    .AddCookie(CookieAuthenticationDefaults.AuthenticationScheme, options =>
    {
        // Ǝ̃OCy[W URL
        options.LoginPath = "/Login";
    });
}
if (authSettings != null && authSettings.IsLoginEnabled) // OCL̏ꍇ
{
    // FT[rXǉ
    builder.Services.AddAuthorization();
    builder.Services.AddAuthentication(); // F؃T[rXĒǉiɒǉĂ邽ߏdĂj
}

// ݒ DI Reiɒǉ
builder.Services.Configure<AuthenticationSettings>(
    builder.Configuration.GetSection("AuthenticationSettings"));


// ݒt@C̒ǉ
builder.Configuration
    .AddJsonFile("appsettings.json", optional: true, reloadOnChange: true) // ftHgݒt@C
    .AddJsonFile($"appsettings.{builder.Environment.EnvironmentName}.json", optional: true); // ʐݒt@C

// AppSettings NX DI Reiɓo^
builder.Services.Configure<AppSettings>(builder.Configuration.GetSection("AppSettings"));

// VOgŃT[rXǉ
builder.Services.AddSingleton<EdgeIF>(); // EdgeIF T[rXǉ
builder.Services.AddSingleton<ClientConnectionHandler>(); // ClientConnectionHandler T[rXǉ

// CircuitHandler XR[vtŒǉiNULL`FbNj
builder.Services.AddScoped<CircuitHandler>(provider =>
{
    var handler = provider.GetService<ClientConnectionHandler>();
    if (handler == null) // NULL̏ꍇɗO𓊂
    {
        throw new InvalidOperationException("ClientConnectionHandler is not registered.");
    }
    return handler;
});

// Serilog ̐ݒiOo͐ƃxݒj
Log.Logger = new LoggerConfiguration()
    .MinimumLevel.Information() // Oxȏɐݒ
    .WriteTo.Console() // R\[ɏo
    .WriteTo.File("Logs/myapp.txt", rollingInterval: RollingInterval.Day) // t@Cɏói[I[o[ݒj
    .CreateLogger();

// Serilog gp悤ɃzXgɐݒ
builder.Host.UseSerilog();

// KvȃT[rX̒ǉiRazor Pagesj
builder.Services.AddRazorPages(); // Razor Pages T[rX̒ǉ

// HTTPNCAgT[rX̒ǉ
builder.Services.AddHttpClient();

// AvP[Vrh
var app = builder.Build();

// HTTPNGXgpCvC̐ݒ
if (!app.Environment.IsDevelopment()) // JłȂꍇ
{
    app.UseExceptionHandler("/Error", createScopeForErrors: true); // G[nhO
    app.UseHsts(); // HTTP Strict Transport Security (HSTS) L
}

app.UseHttpsRedirection(); // HTTPS _CNg
app.UseStaticFiles(); // ÓIt@C̒
app.UseRouting(); // [eBO̐ݒ
app.UseAntiforgery(); // NXTCgNGXgtH[WF (CSRF) ΍

// F؂ƔF̃~hEFAǉiOCLȏꍇ̂݁j
if (authSettings != null && authSettings.IsLoginEnabled)
{
    app.UseAuthentication(); // F؃~hEFA̒ǉ
    app.UseAuthorization(); // F~hEFA̒ǉ
}

// Razor R|[lg̃}bsOiC^NeBuT[o[[hj
app.MapRazorComponents<App>()
    .AddInteractiveServerRenderMode();

// Razor Pages ̃[eBO
app.MapRazorPages();

// API Rg[̃[eBO
app.MapControllers();

// AvP[V̎s
app.Run();



