﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
// HMI_ChartLine 名前空間
using System;
using System.Collections.Generic;
using System.Xml.Serialization;

namespace HMI_Chart
{
#nullable disable
    public class ChartModel
    {
        public string type { get; set; }
        public ChartData data { get; set; }
        public ChartOptions options { get; set; }
    }

    public class ChartData
    {
        public string[] labels { get; set; }
        public Dataset[] datasets { get; set; }
    }

    public class Dataset
    {
        public string label { get; set; }
        public string borderColor { get; set; }
        public string backgroundColor { get; set; }
        public int borderWidth { get; set; }
        public string yAxisID { get; set; }
        public bool fill { get; set; }
        public IEnumerable<float> data { get; set; }
    }

    public class Plugins
    {
        public Legend legend { get; set; }
        public Title title { get; set; }

    }

    public class ChartOptions
    {
        public class Interaction
        {
            public string mode { get; set; }
            public bool intersect { get; set; }
        }

        public Interaction interaction { get; set; }

        public bool responsive { get; set; }

        public Tooltip tooltip { get; set; }
        public Scales scales { get; set; }
        public Plugins plugins { get; set; }

        public bool animation { get; set; }

        public bool maintainAspectRatio { get; set; }
    }

    public class Title
    {
        public bool display { get; set; }
        public string text { get; set; }
        public string color { get; set; }
        public Font font { get; set; }
    }

    public class Tooltip
    {
        public string mode { get; set; }
        public bool intersect { get; set; }
    }

    public class Legend
    {
        public bool display { get; set; }
        public string position { get; set; }
        public Labels labels { get; set; }
    }

    public class Labels
    {
        public int boxWidth { get; set; }
        public Font font { get; set; }
    }

    public class Scales
    {
        public ChartAxis x { get; set; }
        public ChartAxis y1 { get; set; }
        public ChartAxis y2 { get; set; }
    }

    public class ChartAxis
    {
        public string type { get; set; }
        public string id { get; set; } // IDを追加
        public string position { get; set; }
        public Ticks ticks { get; set; }
        public Grid grid { get; set; }

        public bool beginAtZero { get; set; }
    }

    public class Ticks
    {
        public Font font { get; set; }
        public string color { get; set; }
        public float max { get; set; }
        public float min { get; set; }
        public float stepSize { get; set; }
        public bool display { get; set; }
    }

    public class Grid
    {
        public bool display { get; set; }
        public string borderColor { get; set; }
        public string color { get; set; }
        public string tickColor { get; set; }
    }

    public class Font
    {
        public int size { get; set; }
    }

#nullable restore
}