﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
function renderChart(data, chartId) {
    console.log("renderChart 0");
    // オブジェクトとして初期化
    if (!window.chartObjects) {
        window.chartObjects = {};
        console.log("renderChart 1");
    }
    // 既存のチャートがあれば更新
    if (window.chartObjects[chartId]) {
        var newData = JSON.parse(data);

        // ラベルとデータを更新
        window.chartObjects[chartId].data.labels = newData.data.labels;
        window.chartObjects[chartId].data.datasets = newData.data.datasets;

        // オプションも更新したい場合
        window.chartObjects[chartId].options = newData.options;

        // チャートを再描画
        window.chartObjects[chartId].update();

    }
    else {
        console.log("chart open1 : " + chartId);
        console.log("json=" + data);

        var ctx = document.getElementById(chartId);
        if (!ctx) {
            console.error("Canvas element with id " + chartId + " not found.");
            return;
        }

        ctx = ctx.getContext('2d');  // getContextを取得
        console.log("renderChart 7");

        try {

            console.log("Creating new chart for1: " + chartId);
            // JSONをパースして新しいチャートを作成
            window.chartObjects[chartId] = new Chart(ctx, JSON.parse(data));

            if (window.chartObjects[chartId]) {
                console.log("Chart created successfully for: " + chartId);
                console.log(window.chartObjects[chartId].config.data.datasets);
                console.log("Chart.js version: " + window.chartObjects[chartId].version);

            } else {
                console.error("Chart object was not created.");

            }
        } catch (error) {
            console.error("Error creating chart:", error);

        }
    }

    console.log("Rendering finished for: " + chartId);
}