﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Xml.Serialization;
using HMI_CommonLibrary;

namespace HMI_LogViewTable
{
    // .net core 3.0以上 または .NET 5以上 ここ以下の行はnull許容参照型が無効になる(従来通り)
#if NETCOREAPP || NET5_0_OR_GREATER
#nullable disable
#else
#endif
    public class XmlTableData
    {
        [XmlElement("Column")]
        public List<XmlTableColumn> XmlColumns { get; set; }
    }
    public class XmlTableColumn
    {
        [XmlAttribute("Header")]
        public string Header { get; set; } = "";
        [XmlAttribute("Digit")]
        public int Digit { get; set; } = 0;
        [XmlAttribute("ColWidth")]
        public string ColWidth { get; set; } = ""; 
        [XmlAttribute("IsTag")]
        public bool IsTag { get; set; } = true; 
        [XmlElement("Row")]
        public List<string> XmlRows { get; set; }
    }

    public class RowValue
    {
        public List<HmiData> ColValues { get; set; }
        public RowValue()
        {
            ColValues = new List<HmiData>();
        }
    }

#if NETCOREAPP || NET5_0_OR_GREATER
#nullable restore
#else
#endif
}
