﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

// .net core 3.0以上 または .NET 5以上 ここ以下の行はnull許容参照型が無効になる(従来通り)
#if NETCOREAPP || NET5_0_OR_GREATER
#nullable disable
#else
#endif

namespace HMI_Container
{
    /// <summary>
    /// 共通関数、定数クラス
    /// </summary>
    public class HMI_Static
    {
        /// <summary>
        /// 名前付きパイプ名：入力
        /// </summary>
        public static readonly string HMI_PIPE_IN_NAME = @"\\.\pipe\HMIServI";

        /// <summary>
        /// 名前付きパイプ名：出力
        /// </summary>
        public static readonly string HMI_PIPE_OUT_NAME = @"\\.\pipe\HMIServO";
        /// <summary>
        /// BASE側で使用するパイプを使用した通信時の排他制御 mutex名
        /// </summary>
        public static readonly string HMI_PIPE_IN_BASE_MUTEX_NAME = @"Global\pipe_HMIServI";
        public static readonly string HMI_PIPE_OUT_BASE_MUTEX_NAME = @"Global\pipe_HMIServO";

        /// <summary>
        /// エラー
        /// </summary>
        public enum ErrCode : UInt32
        {
            /// <summary>
            /// 正常終了
            /// </summary>
            Ok = 0,

            // ========================================
            // 生成に関するエラー
            // ========================================
            /// <summary>
            /// 既に生成済み
            /// </summary>
            AlreadyCreate,
            /// <summary>
            /// 生成していない
            /// </summary>
            NotCreate,

            // ========================================
            // オープンに関するエラー
            // ========================================
            /// <summary>
            /// 既にオープン済み
            /// </summary>
            AlreadyOpen,
            /// <summary>
            /// オープンしていない
            /// </summary>
            NotOpen,

            // ========================================
            // クローズに関するエラー
            // ========================================
            /// <summary>
            /// 既にクローズ済み
            /// </summary>
            AlreadyClose,

            // ========================================
            // コネクトに関するエラー
            // ========================================
            /// <summary>
            /// 既に接続済み
            /// </summary>
            AlredyConnect,
            /// <summary>
            /// 接続していない
            /// </summary>
            NotConnect,
            // ========================================
            // その他
            // ========================================
            /// <summary>
            /// 引数エラー
            /// </summary>
            ArgumentIsInvalid,

        }


    }
    /// <summary>
    /// Tagの型一覧
    /// </summary>
    public enum egTagDataType
    {
        UNDEFINE = 0,
        Boolean = 1,
        SByte = 2,
        Byte = 3,
        Int16 = 4,
        UInt16 = 5,
        Int32 = 6,
        UInt32 = 7,
        Int64 = 8,
        UInt64 = 9,
        Float = 10,
        Double = 11,
        String = 12,
        Segment = 13 //(Byte配列)
    };
}
// .net core 3.0以上 または .NET 5以上 ここ以下の行はnull許容参照型が有効になる
#if NETCOREAPP || NET5_0_OR_GREATER
#nullable restore
#else
#endif
